#behind every AI player is an armor stand "puppet master" sitting at worldspawn
#this makes sure its respective AI entity respawns after death and etc

#make sure entity exists and isn't missing and respawn if needed
function sprint_racer:ai/general/check_if_alive/_index

tag @s add currentMaster


#identify the entity that belongs to this AImaster for use throughout this function and its children
execute if entity @s[scores={rNumber=1}] run tag @e[tag=ai1,scores={validAI1=1..}] add myCHILD
execute if entity @s[scores={rNumber=2}] run tag @e[tag=ai2,scores={validAI2=1..}] add myCHILD
execute if entity @s[scores={rNumber=3}] run tag @e[tag=ai3,scores={validAI3=1..}] add myCHILD
execute if entity @s[scores={rNumber=4}] run tag @e[tag=ai4,scores={validAI4=1..}] add myCHILD
execute if entity @s[scores={rNumber=5}] run tag @e[tag=ai5,scores={validAI5=1..}] add myCHILD
execute if entity @s[scores={rNumber=6}] run tag @e[tag=ai6,scores={validAI6=1..}] add myCHILD
execute if entity @s[scores={rNumber=7}] run tag @e[tag=ai7,scores={validAI7=1..}] add myCHILD
execute if entity @s[scores={rNumber=8}] run tag @e[tag=ai8,scores={validAI8=1..}] add myCHILD
execute if entity @s[scores={rNumber=9}] run tag @e[tag=ai9,scores={validAI9=1..}] add myCHILD

execute as @e[tag=myCHILD] at @s if block ~ ~ ~ water run tag @s add inWater


#item cooldown
scoreboard players remove @e[tag=myCHILD,scores={itemCooldown=1..}] itemCooldown 1


#increment lifetime score for ai entity
scoreboard players add @e[tag=myCHILD] aiLifetime 1

#ai invulnerability
execute as @e[tag=myCHILD] if entity @s[nbt={Invulnerable:0b},scores={nResist=1..}] run data merge entity @s {Invulnerable:1b}
execute as @e[tag=myCHILD] if entity @s[nbt={Invulnerable:0b},scores={invulTime=1..}] run data merge entity @s {Invulnerable:1b}
execute as @e[tag=myCHILD] if entity @s[nbt={Invulnerable:1b},scores={invulTime=..0,nResist=..0}] run data merge entity @s {Invulnerable:0b}

#AI picks up items on the ground
execute as @e[tag=myCHILD] at @s if entity @e[tag=!capsuleItem,tag=!pickedUP,distance=..2,type=item,nbt={Item:{tag:{Tags:["item"]}}}] run function sprint_racer:ai/general/item_logic/pick_up/pick_up_main

#ai movement calculations (done by ai entity)
execute as @e[tag=myCHILD] at @s run function sprint_racer:coordinates
execute as @e[tag=myCHILD] at @s run function sprint_racer:ai/general/movespeed


#ai can't move while airborne after damage was taken
execute as @e[tag=myCHILD,tag=aiGotOwie,nbt={OnGround:1b}] run tag @s remove aiGotOwie

#ai calculates its current health and how much damage it may have taken
#NOTE: ai has an extra 1000HP so we can make it do a few things instead of just vanishing instantly at 0HP
execute as @e[tag=myCHILD] at @s run function sprint_racer:ai/general/health_calculation
execute as @e[tag=myCHILD,scores={damage=1..}] at @s run function sprint_racer:damage_logic/damage_slowdown_ai

#die when HP drops below 1000
execute as @e[tag=myCHILD,scores={hitboxHP=..1000}] run function sprint_racer:ai/general/die_maybe


###BEHAVIOR STUFF
#ai behavior logic, changes depending on situation
execute if entity @e[name=w,scores={gameState=1}] run function sprint_racer:ai/race/_main_behavior_logic
execute if entity @e[name=w,scores={gameState=3}] run function sprint_racer:ai/battle/_main_behavior_logic

#sub-behavior timer, resets sub behavior to 0 when it expires
scoreboard players remove @e[tag=myCHILD,scores={aiSubBTimer=1..}] aiSubBTimer 1
scoreboard players set @e[tag=myCHILD,scores={aiSubBTimer=1}] aiSubBehavior 0

#ai behavior
execute as @e[tag=myCHILD,scores={aiBehavior=1,aiSubBehavior=..0}] at @s run function sprint_racer:ai/general/behaviors/follow_breadcrumb/_follow_breadcrumb_main
execute as @e[tag=myCHILD,scores={aiBehavior=3,aiSubBehavior=..0}] at @s run function sprint_racer:ai/general/behaviors/chase_player/_chase_player_main
execute as @e[tag=myCHILD,scores={aiBehavior=4,aiSubBehavior=..0}] at @s run function sprint_racer:ai/general/behaviors/evade_player/_evade_player_main
#...
execute as @e[tag=myCHILD,scores={aiSubBehavior=1}] at @s run function sprint_racer:ai/general/behaviors/move_toward_itemchest/_mti_main
execute as @e[tag=myCHILD,scores={aiSubBehavior=5}] at @s run function sprint_racer:ai/general/behaviors/elytra_flight/elytra_main
#...
###


#forced redirection
execute as @e[tag=myCHILD] at @s if entity @e[distance=..10,tag=node,tag=AIBC,scores={AIBC_event=7}] run function sprint_racer:ai/general/aibc_redirection
execute as @e[tag=myCHILD,scores={aiDelayNewPath=0..}] at @s run function sprint_racer:ai/general/delay_new_path

#force reset node
execute if entity @e[name=w,scores={gameState=1}] as @e[tag=myCHILD] at @s if entity @e[distance=..10,tag=node,tag=AIBC,scores={AIBC_event=8}] run function sprint_racer:ai/general/aibc_reset

#who we moving at?
execute as @e[tag=myCHILD] at @s run function sprint_racer:ai/general/confirm_move_target/_index

#attack nearby players if able
execute as @e[tag=myCHILD,tag=aiStronk] at @s run function sprint_racer:ai/general/direct_attack/_main

#cooldown for certain AI decisions
scoreboard players remove @e[tag=myCHILD,scores={aiActCCooldown=1..}] aiActCCooldown 1
execute if entity @e[name=w,tag=halftick] run scoreboard players remove @e[tag=myCHILD,scores={aiActCCooldown=1..}] aiActCCooldown 1
scoreboard players remove @e[tag=myCHILD,scores={aiReverseCooldn=1..}] aiReverseCooldn 1
execute if entity @e[name=w,tag=halftick] run scoreboard players remove @e[tag=myCHILD,scores={aiReverseCooldn=1..}] aiReverseCooldn 1
scoreboard players remove @e[tag=myCHILD,scores={aiActMCooldown=1..}] aiActMCooldown 1
execute unless entity @e[name=w,tag=halftick] run scoreboard players remove @e[tag=myCHILD,scores={aiActICooldown=10..}] aiActICooldown 1
execute if entity @e[name=w,tag=halftick] run scoreboard players remove @e[tag=myCHILD,scores={aiActICooldown=10..}] aiActICooldown 2
scoreboard players remove @e[tag=myCHILD,scores={inputCooldown=..0,aiActICooldown=1..9}] aiActICooldown 1
execute as @e[tag=myCHILD,scores={aiActICooldown=5,aiHoldingItem=1..}] at @s run function sprint_racer:ai/general/item_logic/holding_item
execute as @e[tag=myCHILD,scores={aiActICooldown=..1}] at @s run function sprint_racer:ai/general/item_logic/improvise/_improvise_main

#are we stuck? do something!
tag @e[tag=myCHILD,tag=inWater,scores={aiStuckTime=5..}] add aiswimup
execute if entity @e[tag=myCHILD,tag=!inWater,scores={aiStuckTime=10..}] run tag @s add aijump
execute if entity @e[tag=myCHILD,tag=inWater,tag=aiswimup] as @e[tag=myCHILD] at @s run function sprint_racer:ai/general/swim_up
#execute as @e[tag=myCHILD,tag=inWater,scores={aiStuckTime=29}] at @s run function sprint_racer:ai/general/behaviors/follow_breadcrumb/battle_get_unstuck
execute if entity @e[name=w,scores={gameState=1}] as @e[tag=myCHILD,scores={aiStuckTime=40..}] at @s run function sprint_racer:ai/general/reset
execute unless entity @e[name=w,scores={gameState=1}] as @e[tag=myCHILD,scores={aiStuckTime=40..}] at @s run function sprint_racer:ai/general/behaviors/follow_breadcrumb/create_new_target/battle_get_unstuck
execute if entity @e[name=w,scores={gameTime=160..}] as @e[tag=myCHILD,scores={moveState=..2}] at @s run function sprint_racer:ai/general/check_if_stuck_2
execute if entity @e[name=w,scores={gameState=1}] as @e[tag=myCHILD,scores={aiStuckTime2=40..}] at @s run function sprint_racer:ai/general/reset
execute unless entity @e[name=w,scores={gameState=1}] as @e[tag=myCHILD,scores={aiStuckTime2=40..}] at @s run function sprint_racer:ai/general/behaviors/follow_breadcrumb/create_new_target/battle_get_unstuck

#react to navigation stuff, such as missed checkpoints and being off-course
execute as @e[tag=myCHILD] at @s run function sprint_racer:ai/race/nav_logic

#jump stuff
scoreboard players operation @s aiJBIntensity = @e[tag=myCHILD] aiJBIntensity
scoreboard players operation @s aiJBTime = @e[tag=myCHILD] aiJBTime
execute if entity @e[tag=myCHILD] if entity @e[name=w,tag=halftick] run scoreboard players remove @s[scores={aiJBDelay=3..}] aiJBDelay 1
execute if entity @e[tag=myCHILD] run scoreboard players remove @s[scores={aiJBDelay=1..}] aiJBDelay 1
tag @s[scores={aiJBDelay=1}] add aijump
execute if entity @e[name=w,tag=halftick] run scoreboard players remove @s[scores={aiJBTime=3..}] aiJBTime 1
scoreboard players remove @s[scores={aiJBTime=1..}] aiJBTime 1
scoreboard players set @s[scores={aiJBTime=1}] aiJBIntensity 0
execute if entity @e[tag=myCHILD,nbt={OnGround:1b}] if entity @s[tag=aijump] as @e[tag=myCHILD] at @s run function sprint_racer:ai/general/jump/_index
execute if entity @e[tag=myCHILD,nbt={OnGround:1b}] run tag @s remove aijump
scoreboard players operation @e[tag=myCHILD] aiJBIntensity = @s aiJBIntensity
scoreboard players operation @e[tag=myCHILD] aiJBTime = @s aiJBTime

#movement state calculation
execute as @e[tag=myCHILD] run scoreboard players set @s moveState 0
execute as @e[tag=myCHILD] run scoreboard players set @s[scores={aiBehavior=..4},tag=!aiHealing,nbt={OnGround:1b}] moveState 2
execute as @e[tag=myCHILD] run scoreboard players set @s[scores={aiBehavior=..4},tag=inWater] moveState 2
execute as @e[tag=myCHILD] run scoreboard players set @s[tag=aiHealing,tag=!inWater] moveState 3

#healing logic
execute as @e[tag=myCHILD,scores={hitboxHP=..1019}] at @s run function sprint_racer:ai/general/heal_logic/_index
tag @e[tag=myCHILD,tag=aiHealing,scores={hitboxHP=1020..}] remove aiHealing
execute as @e[tag=myCHILD,scores={moveState=3}] at @s run function sprint_racer:ai/general/sneak_regen

#alright now let's MOVE
execute if entity @e[name=w,scores={gameTime=160..}] as @e[tag=myCHILD] at @s unless entity @s[scores={aiBehavior=..0}] unless entity @s[scores={aiBehavior=5}] run function sprint_racer:ai/general/movement/move_at_target
tag @e[tag=myCHILDtarget] remove myCHILDtarget



#ender pearl teleport
execute as @e[tag=myCHILD,scores={aiPearlTime=0..}] at @s run function sprint_racer:ai/general/check_for_enderpearl

#change item held in hands when needed
execute as @e[tag=myCHILD] run scoreboard players operation @s aiDHoldItem -= @s aiHoldingItem
execute as @e[tag=myCHILD] run execute unless entity @s[scores={aiDHoldItem=0}] run function sprint_racer:ai/general/item_logic/visual_held_item/_index
execute as @e[tag=myCHILD] run scoreboard players operation @s aiDHoldItem = @s aiHoldingItem

#clean up tags
tag @e[tag=myCHILD] remove myCHILD
tag @s remove currentMaster
tag @e[tag=inWater,tag=ai] remove inWater